# Set this to 1 when in devel stage
# Set this back to 0 when at RC stage
%define am_i_cauldron 0

%if %{distro_arch} == "x86_64"
%global secondary_distarch i586
%endif

Name:     mageia-repos
# When Cauldron becomes new release, Version must match new release
Version:  6
# During Cauldron devel, it should be 0.0.X
# During release candidate, it should be 0.1.X
# Before final release, bump to 1
Release:  %mkrel 0.1.1
Summary:  Mageia package repositories
Group:    System/Packaging
License:  MIT

# Mageia GPG key
Source0:  RPM-GPG-KEY-Mageia

# Mageia release repo config templates
Source1:  mageia-core-repo
Source2:  mageia-extrasect-repo
Source3:  mageia-core-srcrepo
Source4:  mageia-extrasect-srcrepo

# Cauldron repo config templates
Source5:  cauldron-core-repo
Source6:  cauldron-extrasect-repo
Source7:  cauldron-core-srcrepo
Source8:  cauldron-extrasect-srcrepo

Provides: mageia-repos(%{version})
Provides: mageia-repos(releasever) = %{version}
Requires: system-release(releasever) = %{version}
Requires: mageia-repos-pkgprefs = %{version}-%{release}
Requires: mageia-repos-keys = %{version}-%{release}

# At RC stage, after switching off am_i_cauldron, add the appropriate Obsoletes
#Obsoletes: mageia-repos-cauldron < VERSION-0.1

# Remove after Cauldron becomes Mageia 7
Obsoletes: mageia-repos-cauldron < 6-0.1

%if %am_i_cauldron
Requires: mageia-repos-cauldron = %{version}-%{release}
%endif

%description
Mageia package repository files for DNF and PackageKit with GPG public keys


%package keys
Summary:  Mageia repository GPG keys
Group:    System/Packaging
# GPG keys are architecture independent
BuildArch: noarch

%description keys
Mageia GPG keys for validating packages from Mageia repositories by
DNF and PackageKit.

%package pkgprefs
# (ngompa): See the following page on why this exists:
# https://fedoraproject.org/wiki/PackagingDrafts/ProvidesPreferences#Distribution_preference
Summary:  Mageia repository package preferences
Group:    System/Packaging
# Preferences list is architecture independent
BuildArch: noarch

## Base packages

# webfetch
Suggests: curl

# webclient
Suggests: lynx

# bootloader
Suggests: grub2

# vim
Suggests: vim-minimal

# Always prefer perl-base over weird packages auto-providing same modules
Suggests: perl-base

# libGL.so.1 (also provided by proprietary drivers)
Suggests: libmesagl1
Suggests: lib64mesagl1

# Prefer openssl over libressl
Suggests: libopenssl1.0.0
Suggests: lib64openssl1.0.0

# Prefer openssh-askpass over openssh-askpass-gnome (for keychain)
Suggests: openssh-askpass

# Python 2.7
Suggests: python

# Initrd
Suggests: dracut

## Multimedia

# festival-voice
Suggests: festvox-kallpc16k

# gnome-speech-driver
Suggests: gnome-speech-driver-espeak

# esound
Suggests: pulseaudio-esound-compat

# gst-install-plugins-helper
Suggests: packagekit-gstreamer-plugin

# libbaconvideowidget.so.0 (totem backend)
Suggests: libbaconvideowidget-gstreamer0
Suggests: lib64baconvideowidget-gstreamer0

# phonon-backend: prefer phonon-vlc over phonon-gstreamer
Suggests: phonon-vlc

# phonon4qt5-backend: prefer phonon4qt5-vlc over phonon4qt5-gstreamer
Suggests: phonon4qt5-vlc

# mate backends
Suggests: matemixer-backend-pulse

# mate menu layout
Suggests: matemenu-mageia-layout

## Devel

# xemacs-extras provides ctags, prefer simple ctags
Suggests: ctags

# prefer openssl-devel over libressl-devel
Suggests: libopenssl-devel
Suggests: lib64openssl-devel

# prefer gcc over gcc3.3
# (gcc-cpp and gcc-c++ are no more needed, but keeping just in case)
Suggests: gcc
Suggests: gcc-cpp
Suggests: gcc-c++
Suggests: libstdc++-devel

# prefer dnf-utils over urpmi-debuginfo-install
# (when using dnf, this is preferred, urpmi will prefer urpmi-debuginfo-install)
Suggests: dnf-utils

# prefer over lib(64)ossp_uuid packages
Suggests: libuuid-devel
Suggests: lib64uuid-devel

# prefer MIT krb5 over heimdal
Suggests: libkrb53-devel
Suggests: lib64krb53-devel

## Servers

# sendmail-command and mail-server
Suggests: postfix

# webserver
Suggests: apache

# nfs-server
Suggests: nfs-utils

# ftpserver
Suggests: proftpd

# postgresql
Suggests: libpq5
Suggests: lib64pq5

# syslog-daemon
Suggests: rsyslog

# vnc
Suggests: tigervnc

# x2goserver database backend
Suggests: x2goserver-sqlite

## Various
# sane (also provided by saned)
Suggests: sane-backends

# virtual-notification-daemon
Suggests: notification-daemon

# sgml-tools
# (the other choice is linuxdoc-tools which requires docbook-utils anyway)
Suggests: docbook-utils

# input method
Suggests: ibus
Suggests: pyzy-db-open-phrase
Suggests: ibus-ui-gtk3
# plasma-applet-kimpanel-backend: prefer plasma-applet-kimpanel-backend-ibus to plasma-applet-kimpanel-backend-scim
# Removed due to bug 8459
#Suggests: plasma-applet-kimpanel-backend-ibus 

# drupal database storage
Suggests: drupal-mysql

# polkit-agent
Suggests: mate-polkit

# java
Suggests: java-1.8.0-openjdk
Suggests: java-1.8.0-openjdk-devel

# java-plugin
Suggests: icedtea-web

# kde-display-management: prefer kscreen to krandr for mga4
Suggests: kscreen

# lightdm greeter
Suggests: lightdm-gtk3-greeter

# prefer netcat-traditional over netcat-openbsd since it is explicitly required by task-printing
# and the netcat packages are conflicting
Suggests: netcat-traditional

%description pkgprefs
This package supplies DNF and PackageKit with global
preferences for packages in which multiple options are possible.


%package cauldron
Summary:        Cauldron repo definitions
Group:          System/Packaging
Requires:       mageia-repos = %{version}-%{release}

%description cauldron
This package provides the Cauldron repo definitions


%prep
# Nothing to prepare

%build
# Nothing to build

%install
# Install the GPG key
mkdir -p %{buildroot}%{_sysconfdir}/pki/rpm-gpg
install %{S:0} -pm 0644 %{buildroot}%{_sysconfdir}/pki/rpm-gpg

# Install the repositories
mkdir -p %{buildroot}%{_sysconfdir}/yum.repos.d

## Create the repositories for various sections
install %{S:1} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-%{distro_arch}.repo
install %{S:3} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-%{distro_arch}-source.repo
install %{S:4} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-nonfree-%{distro_arch}-source.repo
install %{S:4} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-tainted-%{distro_arch}-source.repo
install %{S:2} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-nonfree-%{distro_arch}.repo
install %{S:2} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-tainted-%{distro_arch}.repo

## Create the repositories for Cauldron
install %{S:5} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-%{distro_arch}.repo
install %{S:7} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-%{distro_arch}-source.repo
install %{S:8} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-nonfree-%{distro_arch}-source.repo
install %{S:8} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-tainted-%{distro_arch}-source.repo
install %{S:6} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-nonfree-%{distro_arch}.repo
install %{S:6} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-tainted-%{distro_arch}.repo

## Fill in the correct values for the installed repo files
sed -e "s/@DIST_ARCH@/%{distro_arch}/g" -i %{buildroot}%{_sysconfdir}/yum.repos.d/*%{distro_arch}*.repo

sed -e "s/@DIST_SECTION@/nonfree/g" \
    -e "s/@DIST_SECTION_NAME@/Nonfree/g" \
    -i %{buildroot}%{_sysconfdir}/yum.repos.d/*nonfree*%{distro_arch}*.repo

sed -e "s/@DIST_SECTION@/tainted/g" \
    -e "s/@DIST_SECTION_NAME@/Tainted/g" \
    -i %{buildroot}%{_sysconfdir}/yum.repos.d/*tainted*%{distro_arch}*.repo

## Disable all nonfree and tainted repositories by default
sed -e "s/enabled=1/enabled=0/g" -i %{buildroot}%{_sysconfdir}/yum.repos.d/*nonfree*%{distro_arch}*.repo
sed -e "s/enabled=1/enabled=0/g" -i %{buildroot}%{_sysconfdir}/yum.repos.d/*tainted*%{distro_arch}*.repo

## For architectures with a secondary arch, we need to create repositories for them, too
%if %{defined secondary_distarch}
### Create the repositories for various sections, excluding sources (as they are identical to primary arch ones)
install %{S:1} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-%{secondary_distarch}.repo
install %{S:2} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-nonfree-%{secondary_distarch}.repo
install %{S:2} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/mageia-tainted-%{secondary_distarch}.repo

### Create the repositories for Cauldron, excluding sources (as they are identical to primary arch ones)
install %{S:5} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-%{secondary_distarch}.repo
install %{S:6} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-nonfree-%{secondary_distarch}.repo
install %{S:6} -pm 0644 %{buildroot}%{_sysconfdir}/yum.repos.d/cauldron-tainted-%{secondary_distarch}.repo

### Fill in the correct values for the installed repo files
sed -e "s/@DIST_ARCH@/%{secondary_distarch}/g" -i %{buildroot}%{_sysconfdir}/yum.repos.d/*%{secondary_distarch}*.repo

sed -e "s/@DIST_SECTION@/nonfree/g" \
    -e "s/@DIST_SECTION_NAME@/Nonfree/g" \
    -i %{buildroot}%{_sysconfdir}/yum.repos.d/*nonfree*%{secondary_distarch}*.repo

sed -e "s/@DIST_SECTION@/tainted/g" \
    -e "s/@DIST_SECTION_NAME@/Tainted/g" \
    -i %{buildroot}%{_sysconfdir}/yum.repos.d/*tainted*%{secondary_distarch}*.repo

### Disable all secondary arch repositories by default
sed -e "s/enabled=1/enabled=0/g" -i %{buildroot}%{_sysconfdir}/yum.repos.d/*%{secondary_distarch}*.repo

%endif


%check
%if %am_i_cauldron
case %release in 
    0.*) ;;
    *)
    echo "Cauldron distro should have this package with release < %{mkrel 1}"
    exit 1
    ;;
esac
%endif


%files
%dir %{_sysconfdir}/yum.repos.d
%config(noreplace) %{_sysconfdir}/yum.repos.d/mageia*.repo

%files keys
%dir %{_sysconfdir}/pki/rpm-gpg
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-Mageia

%files cauldron
%config(noreplace) %{_sysconfdir}/yum.repos.d/cauldron*.repo

%files pkgprefs




%changelog
* Sun May 28 2017 ngompa <ngompa> 6-0.1.1.mga6
+ Revision: 1105350
- Fix URLs in commented out baseurl= in most repos (mga#20933)

* Thu May 25 2017 ngompa <ngompa> 6-0.1.0.mga6
+ Revision: 1104568
- Disable cauldron build now that we're at RC stage
- Add instructions to spec on how to handle releasing
- Obsolete mageia-repos-cauldron < 6-0.1 for RC

* Sun May 14 2017 ngompa <ngompa> 6-0.0.11.mga6
+ Revision: 1100998
- Prefer dnf-utils for dnf-based installs

* Sun Mar 19 2017 ngompa <ngompa> 6-0.0.10.mga6
+ Revision: 1093585
- Sync with prefer.vendor.list

* Thu Feb 23 2017 ngompa <ngompa> 6-0.0.9.mga6
+ Revision: 1087456
- Sync with prefer.vendor.list (prefer krb5 over heimdal to fix builds)

* Fri Nov 25 2016 ngompa <ngompa> 6-0.0.8.mga6
+ Revision: 1070190
- Sync pkgprefs subpackage with prefer.vendor.list

* Mon Jul 04 2016 ngompa <ngompa> 6-0.0.7.mga6
+ Revision: 1038572
- Fix remaining names of test package repositories

* Sun Jun 26 2016 ngompa <ngompa> 6-0.0.6.mga6
+ Revision: 1037693
- Update the names of test package repositories

* Mon May 30 2016 ngompa <ngompa> 6-0.0.5.mga6
+ Revision: 1019516
- Disable nonfree and tainted repos by default

* Mon May 30 2016 ngompa <ngompa> 6-0.0.4.mga6
+ Revision: 1019469
- Add initial repository configuration

* Fri May 27 2016 ngompa <ngompa> 6-0.0.3.mga6
+ Revision: 1018863
- * Sync pkgprefs with prefer.vendor.list
  * Replace /etc/distro.repos.d with /etc/yum.repos.d
- Add comment on why mageia-repos-pkgprefs exists

* Mon Apr 25 2016 ngompa <ngompa> 6-0.0.2.mga6
+ Revision: 1006001
- Split Suggests onto individual lines

* Sun Apr 24 2016 ngompa <ngompa> 6-0.0.1.mga6
+ Revision: 1005967
- Add Requires for repo keys
- imported package mageia-repos

